<template>
    <div>
        <div v-for="classe in classes" :key="classe.id">
            <div class="uk-flex">
                <input
                    class="uk-checkbox uk-checkbox-header"
                    type="checkbox"
                    v-model="checkedAll[classe.id]"
                    @change="checkAll(classe.id)"
                />
                <label>
                    <div
                        :uk-toggle="
                            'target:#' + getClasseIdToggle(classe.libelle)
                        "
                    >
                        {{ classe.libelle
                        }}<span uk-icon="triangle-down"></span>
                    </div>
                </label>
            </div>
            <ul
                :id="getClasseIdToggle(classe.libelle)"
                class="uk-list uk-margin-medium-left"
                hidden
            >
                <div
                    v-for="eleve in classe.eleves"
                    :key="classe.eleves.indexOf(eleve)"
                >
                    <li>
                        <label>
                            <input
                                class="uk-checkbox"
                                type="checkbox"
                                :id="'statement-option' + eleve.id"
                                :value="eleve.id"
                                v-model="checked[eleve.id]"
                                @change="actionParent()"
                            />
                            {{ eleve.nom }} {{ eleve.prenom }}
                        </label>
                    </li>
                </div>
            </ul>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
// import UtilisateurSorter from '@/components/outils/UtilisateurSorter';
@Component
export default class AffichageClassesEleves extends Vue {
    @Prop() classes: any[];

    private nombreEleves: number;
    private checkedAll: any[] = [];
    private checked: any[] = [];

    mounted() {
        const classeClub = this.classes.find(classe => classe.id == null);
        const idsEleves = classeClub.eleves.map(eleve => eleve.id);
        this.nombreEleves = Math.max(...idsEleves);
    }

    public checkAll(idClasse: number) {
        const selected = new Array(this.nombreEleves);
        if (this.checkedAll[idClasse]) {
            const classeCochee = this.classes.find(
                classe => classe.id == idClasse
            );

            const eleves = classeCochee.eleves;
            eleves.forEach(eleve => {
                selected.splice(eleve.id, 1, true);
            });
        }
        this.checked = selected;
        this.actionParent();
    }

    private getClasseIdToggle(classeLibelle: string): string {
        return classeLibelle.replaceAll(' ', '-');
    }

    private actionParent() {
        const resultat = this.checked.reduce(function(a, e, i) {
            if (e) a.push(i);
            return a;
        }, []);
        this.$emit('action', resultat);
    }

    // private getElevesClasse(classe: Record<string, any>): any[] {
    //     const eleves = classe.eleves;
    //     UtilisateurSorter.comparerUtilisateurs(eleves);
    //     return eleves;
    // }
}
</script>

<style scoped>
.uk-checkbox-header {
    margin-top: 5px;
    margin-right: 8px;
}
</style>
